=begin
##Author : Wikii
##Date    :20090207
##Ver     :0.04

v0.04 20090210
1 if path started at a vertex of profile,the vertex will be treated as align point.
2 auto reverse face to get directviewing result.

v0.03 20090209
1 start at nearest vertex when path is closed
2 fix some bugs

v0.02 20090208
1 perfect ending;
2 autosmooth
=end

module Sketchup
   class Face
      def wi_center#ĵ
         vts=self.vertices.collect{|x| x.position}
         vx=vts.collect{|x| x.x}.wi_average
         vy=vts.collect{|x| x.y}.wi_average
         vz=vts.collect{|x| x.z}.wi_average
         return(Geom::Point3d.new [vx,vy,vz])
      end
   end
end
class Array
   def wi_average#ƽֵ
      re=0
      self.each{|x| re+=x}
      return re / self.length
   end
end #class Array
class Follow_me_keep_z
   @@wikii_push_pull_recodes=[]
   @@wikii_push_pull_rotate=0.0
   @@wikii_push_pull_rotate_step=false
   @@wikii_push_pull_scale=1.0
   @@wikii_push_pull_z=false
   def sort_edges edges
      return if edges.length==0
      re=[]
      while edges.length!=0
         start=nil
         edges.each{|x|
            start=x.start; break  if (x.start.edges&edges).length==1
            start=x.end; break if (x.end.edges&edges).length==1
         }
         vts=[]
         curve=[]
         while start
            next_edge=(start.edges&edges-curve)[0]
            if next_edge
               curve << next_edge
               vts << start
               start=next_edge.other_vertex(start)
            else
               vts << start
               start=nil
            end
         end
         edges-=curve
         re << [curve,vts]
      end
      return re
   end

   def wikii_push_pull
      @@wikii_push_pull_recodes=[]
      Sketchup.active_model.start_operation "wikii_push_pull"
      selection=Sketchup.active_model.selection
      fcs=selection.select{|x| x.typename=="Face"}
      return if fcs.length==0
      e=Sketchup.active_model.selection.select{|x| x.typename=="Edge"}
      e=e-fcs.collect{|x| x.edges}.flatten

      e=sort_edges( e).sort{|x,y| x[0].length <=> y[0].length}

      cp=Sketchup.active_model.selection.select{|x| x.typename=="ConstructionPoint"}

      cv=e[-1][1].collect{|x| x.position}
      closed_path = (cv[0]==cv[-1] ? true : false)


      @@wikii_push_pull_rotate_step=  true
      @@wikii_push_pull_rotate=0
      @@wikii_push_pull_scale=1
      @@wikii_push_pull_z= true

      wikii_push_pull_step_rotate=@@wikii_push_pull_rotate / (@@wikii_push_pull_rotate_step ? 1 : cv.length-1)
      fcs.each{|f|
         cv=e[-1][1].collect{|x| x.position}
         #ȷ·
         fc=nil
         if cp.length!=0#ṩ
            fc=cp[0].position
         else
            case true
            when closed_path
               e[-1][1].each{|av| fc=av.position if av.faces.include?(f)}
               fc=f.wi_center if !fc
            when e[-1][1][0].faces.include?(f)
               fc=e[-1][1][0].position
            when e[-1][1][-1].faces.include?(f)
               fc=e[-1][1][-1].position
            else
               fc=f.wi_center#ʹĵ
            end
         end
         #ȷ·㣬ԾĶ˵Ϊ
         if closed_path#Ϊպ·ѰҾĽڵ
            n=-1
            cv=cv[0..-2]
            min=cv.collect{|x| n+=1;[x.distance(fc),n]}.sort{|x,y| x[0]<=>y[0]}[0][1]
            p min
            cv=cv[min..-1]+cv[0..min]
            cv.uniq!
            cv << cv[0]
         else
            cv.reverse! if cv[0].distance(fc)>cv[-1].distance(fc)
         end
         v= fc-cv[0]
         cv.collect!{|x| x+v}#ƶ·˵㵽
         fvs=f.vertices.collect{|x| x.position}
         #~ if @@wikii_push_pull_per
         #洹ֱ·
         v1=cv[1]-cv[0]
         v2=f.normal
         if f.normal.angle_between(v1)>(Math::PI/2)
            f.reverse!
            v2=f.normal
         end
         v1.z=0
         v2.z=0
         next if v2.length==0 #Ϊˮƽ
         v3=v2*v1
         if v3.length!=0  #xyƽУ
            t= Geom::Transformation.rotation(fc, v3, v1.angle_between(v2))
            fvs.collect!{|x| x.transform t}
            v2=f.normal.transform t
            v3=v2*v1
            if v3.length!=0#ʹ洹ֱ·ʼ
               v3=v2*v1
               t= Geom::Transformation.rotation(fc, v3, v1.angle_between(v2))
               fvs.collect!{|x| x.transform t}
            end
         end
         #~ end

         gp=Sketchup.active_model.active_entities.add_group().entities
         tmp_vts=[]
         if closed_path#·պϣĶ˵Ͷ
            v1=cv[-2]
            v2=cv[0]
            v3=cv[1]
            vca=(v1-v2)
            vcb=(v3-v2)
            vca.z=0 if @@wikii_push_pull_z
            vcb.z=0 if @@wikii_push_pull_z
            vca.length=vcb.length=1
            if 	(vca*vcb).length==0
               normal=vca
            else
               vc1=Geom::Vector3d.linear_combination 1,vca,1,vcb
               vc2=vca*vcb
               normal=vc1*vc2
               normal=vc1 if normal.length==0
            end
            plane=[cv[0],normal]
            fvs.each{|x|
               st1=Geom.intersect_line_plane [x,cv[1]-cv[0]], plane
               tmp_vts << st1
            }
         else#·
            fvs.each{|x|
               tmp_vts <<  x
            }
         end
         nf=gp.add_face(tmp_vts)
         gp.add_cpoint(fc)
         @fvs=fvs=tmp_vts
         edges_not_smooth=[]
         edges_not_smooth_last=[]
         cv.each_index{|x|
            v1=cv[x]
            v2=nil
            v3=nil
            case true
            when (x==cv.length-1 )
               next
            when (x==(cv.length-2))
               if closed_path#·պ
                  v2=cv[x+1]
                  v3=cv[1]
                  fvs.each_index{|ii|
                     edges_not_smooth << (y=gp.add_line(fvs[ii],@fvs[ii]))
                     y.find_faces
                     y=gp.add_line(fvs[ii],@fvs[(ii+1)-@fvs.length])
                     y.find_faces
                  }
                  break
               else
                  v2=cv[x+1]
                  vect=v2-v1
                  vect.z=0 if @@wikii_push_pull_z
                  v3=v2+vect
               end
            else
               v2=cv[x+1]
               v3=cv[x+2]
            end

            vca=(v1-v2)
            vcb=(v3-v2)

            vca.z=0 if @@wikii_push_pull_z
            vcb.z=0 if @@wikii_push_pull_z
            vca.length=vcb.length=1
            normal=nil
            if (vca*vcb).length== 0
               normal=vca
               normal.z=0 if @@wikii_push_pull_z
               plane=[v2,normal]
            else
               vx=vca*vcb
               vx=Geom::Vector3d.new(0, 0, 1) if @@wikii_push_pull_z
               tr=Geom::Transformation.rotation Geom::Point3d.new(0,0,0), vx, vca.angle_between(vcb)/-2
               va=vca+vcb#ƽ
               normal=va*vx
               normal.z=0 if @@wikii_push_pull_z
               plane=[v2,normal]
            end



            fvs=fvs.collect{|xx|
               xx=xx.position if xx.class==Sketchup::Vertex
               p_normal=(v2-v1)
               p_normal.z=0 if @@wikii_push_pull_z
               y=Geom.intersect_line_plane [xx,p_normal], plane
               edges_not_smooth << gp.add_line(xx,y)
               y
            }

            nfc=Geom.intersect_line_plane [fc,v2-v1], plane
            nf.erase! if (!nf.deleted? and x!=0)
            nf=gp.add_face fvs
            edges_not_smooth_last=nf.edges
            @@wikii_push_pull_recodes << [gp,nf.edges,nfc,normal]
            nf.edges.each{|xx| xx.find_faces}

            if @@wikii_push_pull_rotate!=0
               t= Geom::Transformation.rotation( nfc, normal, wikii_push_pull_step_rotate)
               gp.transform_entities( t,nf)
            end
            if @@wikii_push_pull_scale!=1
               t=Geom::Transformation.scaling nfc, @@wikii_push_pull_scale
               gp.transform_entities(  t,nf)
            end
            if @@wikii_push_pull_z
               t=Geom::Transformation.translation Geom::Vector3d.new(0,0,v2.z-v1.z)
               gp.transform_entities(  t,nf)
            end

            fvs=nf.vertices
            fc=nfc
            #~ break
         }
         (gp.to_a-edges_not_smooth-edges_not_smooth_last).each{|x| x.smooth=x.soft=true if x.typename=="Edge"}
         nf.erase! if closed_path
      }
      Sketchup.active_model.commit_operation
   end


   #~ def wikii_push_pull_modify
   #~ Sketchup.active_model.start_operation "wikii_push_pull_modify"
   #~ edges=Sketchup.active_model.selection.select{|x| x.typename=="Edge"}
   #~ return if edges.length==0
   #~ objs=[]
   #~ @@wikii_push_pull_recodes.each{|x|
   #~ objs << x if (x[1]&edges).length!=0
   #~ }
   #~ objs.uniq!
   #~ require "inputbox.rb"
   #~ inp=Inputbox.new ""
   #~ inp.add "ͳһ",%w{Yes No},"Yes"
   #~ inp.add "x",1.0
   #~ inp.add "y",1.0
   #~ inp.add "z",1.0
   #~ re=inp.show
   #~ return if !re
   #~ objs.each{|tmp|

   #~ if re[0]=="Yes"
   #~ t=Geom::Transformation.scaling( tmp[2],re[1])
   #~ else
   #~ t=Geom::Transformation.scaling( tmp[2],re[1],re[2],re[3])
   #~ end
   #~ tmp[0].transform_entities(t ,tmp[1])
   #~ }


   #~ Sketchup.active_model.commit_operation
   #~ end

   if !(defined? Sutool)
      if( not file_loaded?("FAK.rb") )
         add_separator_to_menu("Plugins")
         UI.menu("Plugins").add_item("FollowMeAndKeep") { Follow_me_keep_z.new.wikii_push_pull }
      end
      file_loaded("FAK.rb")
   end
   puts "FAK v0.04 Author:Wikii Date:20090209"
end
#~ clear
#~ Follow_me_keep_z.new.wikii_push_pull
#~ Follow_me_keep_z.new.wikii_push_pull_modify
